

# This is configuration for Qualcomm QCC730 chip

# Target board Qualcomm QCC730
# Master-Slave framwork
#
# FTDI interface driver for MPSSE mode of FT2322H
#
adapter driver ftdi

# The vendor ID and Product ID of the adapter
ftdi vid_pid 0x0403 0x6010

# The USB Device description
# ftdi_device_desc "FT2232C Dual USB-UART/FIFO IC"

# Select the Channel of the FTDI device to use for MPSSE operations
ftdi channel 0

# The initial values of the FTDI GPIO data and direction registers
ftdi layout_init 0x0008 0x00fb

#TODO:trst pull low and high
#ftdi layout_signal nTRST -data 0x0100 -oe 0x0100
# ftdi set_signal name (1|0|z)
transport select jtag

adapter speed 10000

set CHIPNAME QCC730
set TAPTYPE cpu

#set CPUTAPID 0x4ba06477
set CPUTAPID 0x0021b0e1
set IRLEN 7

#
# Qualcomm QCC730 target device
#

if { [info exists TAPTYPE] } {
    set _TAPTYPE $TAPTYPE
} else {
    set _TAPTYPE cpu
}

if { [info exists CHIPNAME] } {
    set _CHIPNAME $CHIPNAME
} else {
    set _CHIPNAME QCC730
}

if { [info exists CPUTAPID] } {
    set _CPUTAPID $CPUTAPID
} else {
    set _CPUTAPID 0x0021b0e1
}

if { [info exists IRLEN] } {
    set _IRLEN $IRLEN
} else {
    set _IRLEN 4
}

proc after_gdb_detach { } {
    echo "continue target and shutdown openocd server"
    resume
    shutdown
}

#By default, set breakpoints as hard breakpoints.
gdb_breakpoint_override hard

#MASTER tap
jtag newtap $_CHIPNAME chp -irlen 7 -ircapture 1 -irmask 0x03

#M4F tap which we want
jtag newtap $_CHIPNAME cpu -irlen 4 -ircapture 1 -irmask 0x03 -disable -expected-id 0x4ba06477

#target configuration - There is only 1 tap at a time, hence only 1 target is defined.
set _TARGETNAME $_CHIPNAME.cpu
dap create $_CHIPNAME.dap -chain-position $_TARGETNAME -adiv6
target create $_TARGETNAME cortex_m -dap $_CHIPNAME.dap -ap-num 0x40000


# Setup the interesting tap
jtag configure $_CHIPNAME.chp -event setup {
     jtag tapenable QCC730.cpu;
     #poll off;
}

#select CORE tap by set private instruction.
#to be used when MASTER tap is selected.
jtag configure $_TARGETNAME -event tap-enable {
	irscan QCC730.chp 0x0B;
    jtag tapdisable QCC730.chp;
}

#select MASTER tap by modifying the register.
#to be used when CORE tap is selected.
jtag configure $_CHIPNAME.chp -event tap-enable {
	echo "master tap-enable"
	jtag tapdisable $_TARGETNAME;
}

#disables the master tap
jtag configure $_TARGETNAME -event tap-disable {
	echo "slave tap-enable"
}

jtag configure $_CHIPNAME.chp -event tap-disable {
	echo "master tap-enable"
}

proc after_gdb_detach { } {
    echo "continue target and shutdown openocd server"
	resume
    shutdown
}
$_TARGETNAME configure -event gdb-detach after_gdb_detach

init
targets
